;==============================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================
    .data
      hInstance dd 0
      hMenuPop  dd 0
    .code
;==============================================================================

DlgProc proc uses ebx hwndDlg:dword, uMsg:dword, wParam:dword, lParam:dword

    LOCAL pt:POINT

    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke CreatePopupMenu
        mov hMenuPop, eax

        invoke AppendMenu, hMenuPop, MF_STRING, 1001, chr$("Option &1")
        invoke AppendMenu, hMenuPop, MF_STRING, 1002, chr$("Option &2")
        invoke AppendMenu, hMenuPop, MF_SEPARATOR, 0, 0
        invoke AppendMenu, hMenuPop, MF_STRING, 1003, chr$("Option &3")
        invoke AppendMenu, hMenuPop, MF_SEPARATOR, 0, 0
        invoke AppendMenu, hMenuPop, MF_STRING, 1004, chr$("Option &4")
        invoke AppendMenu, hMenuPop, MF_STRING, 1005, chr$("Option &5")

      CASE WM_RBUTTONUP

        ;lParam:
        ;The low-order word specifies the x-coordinate of the cursor.
        ;The coordinate is relative to the upper-left corner of the client area.
        ;The high-order word specifies the y-coordinate of the cursor.
        ;The coordinate is relative to the upper-left corner of the client

        mov eax, lParam
        and eax, 0ffffh
        mov pt.x, eax
        mov eax, lParam
        shr eax, 16
        mov pt.y, eax

        invoke ClientToScreen, hwndDlg, addr pt

        invoke TrackPopupMenu, hMenuPop,
                               TPM_LEFTALIGN or \
                               TPM_RETURNCMD or \
                               TPM_TOPALIGN or \
                               TPM_HORPOSANIMATION,
                               pt.x,
                               pt.y,
                               0,
                               hwndDlg,
                               0

        invoke MessageBox, hwndDlg, str$(eax), chr$("Selected ID"), 0

      CASE WM_COMMAND

        SWITCH wParam

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, 0

        ENDSW

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, 0

    ENDSW

    xor eax, eax
    ret

DlgProc endp

;==============================================================================
start:
;==============================================================================

    invoke GetModuleHandle, NULL
    mov hInstance, eax

    Dialog "Test", \
           "MS Sans Serif",8, \
           WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
           0,0,0,100,75,1024

    CallModalDialog hInstance,0,DlgProc,NULL

    exit
;==============================================================================
end start

        invoke GetDlgItem, hwndDlg, 101
        mov hwndMC, eax

        invoke SendMessage, hwndMC, MCM_GETMONTHRANGE,
                            GMR_DAYSTATE, ADDR systime
        print str$(eax),13,10

        movzx eax, systime.wMonth
        print str$(eax),13,10

        movzx eax, systime[SIZEOF SYSTEMTIME].wMonth
        print str$(eax),13,10

        ;---------------------------------------------------------
        ; This is not actually needed because our MCN_GETDAYSTATE
        ; notification handler will perform the same action.
        ;---------------------------------------------------------

        invoke SendMessage, hwndMC, MCM_SETDAYSTATE, 3, ADDR mds
        print str$(eax),13,10
